//Close Positions at MA EA.mq4
#property copyright "Copyright  2014, Marc (fxdaytrader)"
#property link      "http://forexBaron.net"

extern bool FilterByMagicNumber = FALSE;//true:filter by magic number, false:ignore magic numbers
extern bool CurrentPairOnly     = FALSE;//true:current chart pair only, false:all pairs
extern int  MagicNumber         = 0;//0:manual trades

extern bool CloseLongTrades  = TRUE;
extern bool CloseShortTrades = TRUE;
extern bool CloseImmediatelyOnMa = FALSE;//TRUE:close if price><ma, FALSE:close if price crossed the ma (close prices)
extern int  timeframe    = 0;//0:current timeframe
extern int  MaPeriod     = 89;
extern int  MaShift      = 0;
extern int  MaMethod     = MODE_EMA;
extern int  MaPrice      = PRICE_CLOSE;
extern int  SignalCandle = 1;

extern bool PrintToJournal = TRUE;
int totalopenorders;//simple stats

int init() {
 return(0);
}

int deinit() {
 Comment("");
 return(0);
}

int start() {
 CountOpenTrades(Symbol(),MagicNumber);
 CheckForCloseTrades(Symbol(),MagicNumber);
 Comment("Close Positions at MA EA,  2014 Marc (fxdaytrader) *** http://ForexBaron.net"+"\n"+
 "  CloseLongTrades="+bool2txt(CloseLongTrades)+", CloseShortTrades="+bool2txt(CloseShortTrades)+"\n"+
 "  FilterByMagicNumber="+bool2txt(FilterByMagicNumber)+" (MagicNumber="+MagicNumber+"), CurrentPairOnly="+bool2txt(CurrentPairOnly)+" (pair: "+Symbol()+"), total open trades to manage: "+totalopenorders+"\n"+
 "  MA (CloseImmediatelyOnMa="+bool2txt(CloseImmediatelyOnMa)+"): period="+MaPeriod+", tf="+TFtoStr(timeframe)+", shift="+MaShift+",method="+MaMethod+", price="+MaPrice+", SignalCandle="+SignalCandle);
}

int CheckForCloseTradesAtMa(string symbol) {
 double ma      = iMA(symbol,timeframe,MaPeriod,MaShift,MaMethod,MaPrice,SignalCandle);
 double cclose  = iClose(symbol,timeframe,SignalCandle);
 double ma1     = iMA(symbol,timeframe,MaPeriod,MaShift,MaMethod,MaPrice,SignalCandle+1);
 double cclose1 = iClose(symbol,timeframe,SignalCandle+1);
 if (CloseImmediatelyOnMa) {
  if (cclose>ma) return(OP_SELL);
  if (cclose<ma) return(OP_BUY);
 }
 else if (!CloseImmediatelyOnMa) {
  if (cclose>ma&&cclose1<=ma1) return(OP_SELL);
  if (cclose<ma&&cclose1>=ma1) return(OP_BUY);
 }
 return(99);
}

void CheckForCloseTrades(string symbol,int magicnumber) {
 bool result;
 for (int cnt=OrdersTotal()-1; cnt>=0; cnt--) {
  if (!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)) continue;
  if (CurrentPairOnly && OrderSymbol()!=symbol) continue;
  if (FilterByMagicNumber && OrderMagicNumber()!=magicnumber) continue;
   {
     RefreshRates();
     double bid = MarketInfo(OrderSymbol(),MODE_BID);
     double ask = MarketInfo(OrderSymbol(),MODE_ASK);
     if (CloseLongTrades&&CheckForCloseTradesAtMa(OrderSymbol())==OP_BUY) {
      result=OrderClose(OrderTicket(),OrderLots(),bid,99999,CLR_NONE);
      if (PrintToJournal) {
       if (result) Print("Closed BUY ticket="+OrderTicket()+" at MA("+MaPeriod+")");
        else if (!result) Print("ERROR "+GetLastError()+" -> close BUY ticket="+OrderTicket()+" at MA("+MaPeriod+") failed!");
      }//if (PrintToJournal) {
     }
     if (CloseShortTrades&&CheckForCloseTradesAtMa(OrderSymbol())==OP_SELL) {
      result=OrderClose(OrderTicket(),OrderLots(),ask,99999,CLR_NONE);
      if (PrintToJournal) {
       if (result) Print("Closed SELL ticket="+OrderTicket()+" at MA("+MaPeriod+")");
        else if (!result) Print("ERROR "+GetLastError()+" -> close SELL ticket="+OrderTicket()+" at MA("+MaPeriod+") failed!");
      }//if (PrintToJournal) {
     }
    }
  }
}

void CountOpenTrades(string symbol,int magicnumber) {
 totalopenorders=0;
 for (int cnt=OrdersTotal()-1; cnt>=0; cnt--) {
  if (!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)) continue;
  if (CurrentPairOnly && OrderSymbol()!=symbol) continue;
  if (FilterByMagicNumber && OrderMagicNumber()!=magicnumber) continue;
   {
     if (OrderType()<=OP_SELL) totalopenorders++;
    }
  }
}

string bool2txt(int varbool) {
 if (varbool==true) return("yes");
 if (varbool==false) return("no");
}

string TFtoStr(int period) {
 if (period==0) period=Period();
 switch(period) {
  case 1     : return("M1");  break;
  case 5     : return("M5");  break;
  case 15    : return("M15"); break;
  case 30    : return("M30"); break;
  case 60    : return("H1");  break;
  case 240   : return("H4");  break;
  case 1440  : return("D1");  break;
  case 10080 : return("W1");  break;
  case 43200 : return("MN1"); break;
  default    : return(DoubleToStr(period,0));
 }
 return("UNKNOWN");
}